//Code for the Time Attack Helper

local function padTimerZero(num)
	if num < 10
		return "0" .. tostring(num)
	else
		return tostring(num)
	end
end

local function drawTATimer(v, p, xmid, y, flags)
	if not (p and p.valid) then return end
	local littletime = nil
	local littletimestr = "--:--.--"
	local medal = 5
	local medalpatch = v.cachePatch("BIGNEEDIT")
	local medalcol = v.getColormap(0, SKINCOLOR_NONE)
	local medaltimes = {}
	local littletimecolflag = V_GRAYMAP
	local currenttime = p.realtime
	xmid = $ or 160
	y = $ or 4
	if TAMedalTimes[string.upper(G_BuildMapName(gamemap))] then
		medaltimes = GetTAMedalTimes(gamemap)
	else
		medaltimes = {
			[1] = 1,
			[2] = 2,
			[3] = 3,
			[4] = 4
		}
	end
	for i = 1, 4 do
		if currenttime < medaltimes[i] then
			littletime = medaltimes[i] - p.realtime
			if littletimecolflag == V_GRAYMAP then littletimecolflag = 0 end
			littletimestr = padTimerZero(G_TicsToMinutes(littletime, true)) .. ":" .. padTimerZero(G_TicsToSeconds(littletime)) .. "." ..  padTimerZero(G_TicsToCentiseconds(littletime))
			medal = i
			medalpatch = v.cachePatch("BIGGOTITA")
			medalcol = ({
				[1] = v.getColormap(0, SKINCOLOR_PLATINUM),
				[2] = v.getColormap(0, SKINCOLOR_GOLD),
				[3] = v.getColormap(0, SKINCOLOR_SILVER),
				[4] = v.getColormap(0, SKINCOLOR_BRONZE)
			}) [medal]
			break
		elseif currenttime == medaltimes[i] and (p.exiting) then
			littletime = 0
			littletimecolflag = V_ORANGEMAP //You tied the time... But didn't get the medal. RIP.
			littletimestr = padTimerZero(G_TicsToMinutes(littletime, true)) .. ":" .. padTimerZero(G_TicsToSeconds(littletime)) .. "." ..  padTimerZero(G_TicsToCentiseconds(littletime))
			if i < 4 then
				medal = i+1
				medalpatch = v.cachePatch("BIGGOTITA")
				medalcol = ({
					[1] = v.getColormap(0, SKINCOLOR_PLATINUM),
					[2] = v.getColormap(0, SKINCOLOR_GOLD),
					[3] = v.getColormap(0, SKINCOLOR_SILVER),
					[4] = v.getColormap(0, SKINCOLOR_BRONZE)
				}) [medal]
				break
			end
		end
	end
	if littletimecolflag == 0 then
		if p.exiting then
			littletimecolflag = V_GREENMAP
		elseif (littletime < 10*TICRATE) and ((p.realtime % 8) >= 4) then
			littletimecolflag = V_REDMAP
		elseif (littletime >= 10*TICRATE) and (littletime <= 30*TICRATE) and ((p.realtime % 16) >= 8) then
			littletimecolflag = V_YELLOWMAP
		end
	end
	v.drawString(xmid, y, littletimestr, flags|littletimecolflag, "center")
	v.drawScaled((xmid + (4*string.len(littletimestr)))*FRACUNIT, y*FRACUNIT, FRACUNIT/2, medalpatch, flags, medalcol)
end

local function drawTAMedalTimes(v, p, x, y, flags)
	if not (p and p.valid) then return end
	local timestep = false
	local medalpatch = v.cachePatch("BIGGOTITA")
	local currenttime = p.realtime
	local medaltimes = {}
	if TAMedalTimes[string.upper(G_BuildMapName(gamemap))] then
		medaltimes = GetTAMedalTimes(gamemap)
	else
		medaltimes = {
			[1] = 1,
			[2] = 2,
			[3] = 3,
			[4] = 4
		}
	end
	for i = 0, 3 do
		if medaltimes[i+1] then
			local medalcol = ({
				[1] = v.getColormap(0, SKINCOLOR_PLATINUM),
				[2] = v.getColormap(0, SKINCOLOR_GOLD),
				[3] = v.getColormap(0, SKINCOLOR_SILVER),
				[4] = v.getColormap(0, SKINCOLOR_BRONZE)
			}) [i+1]
			local time = medaltimes[i+1]
			local str = padTimerZero(G_TicsToMinutes(time, true)) .. ":" .. padTimerZero(G_TicsToSeconds(time)) .. "." ..  padTimerZero(G_TicsToCentiseconds(time))
			local colflag = 0
			if (not timestep) and (time > currenttime) then 
				if p.exiting then colflag = V_GREENMAP else colflag = V_YELLOWMAP end
				timestep = true
			elseif p.exiting and time == currenttime then //You tied the medal time... but you didn't get it as you have to beat the time, not match it. RIP
				colflag = V_ORANGEMAP
			end
			v.drawScaled(x*FRACUNIT, (y + (10*i))*FRACUNIT, FRACUNIT/2, medalpatch, flags, medalcol)
			if currenttime >= time then 
				local fflags = flags&(~V_HUDTRANS)
				if flags&V_HUDTRANS then
					fflags = $|V_HUDTRANSHALF
				else
					fflags = $|V_50TRANS
				end
				if colflag == 0 then colflag = V_GRAYMAP end
				v.drawScaled(x*FRACUNIT, (y + (10*i))*FRACUNIT, FRACUNIT/2, v.cachePatch("BIGNEEDIT"), fflags)
			end
			v.drawString(x+10, y + (10*i), str, flags|colflag)
		end
	end
end

hud.add(function(v, p, c)
	if modeattacking and not (gametype & GT_SPECIAL) then
		if p.exiting then //Keep this shown at the end of a race
			drawTATimer(v, p, 240, 4, V_SNAPTOTOP|V_SNAPTORIGHT)
			drawTAMedalTimes(v, p, 4, 64, V_SNAPTOTOP|V_SNAPTOLEFT)
		else
			drawTATimer(v, p, 240, 4, V_SNAPTOTOP|V_SNAPTORIGHT|V_HUDTRANS)
			drawTAMedalTimes(v, p, 4, 64, V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS)
		end
	end
end)